//+------------------------------------------------------------------+
//|                                             Price Oscillator.mq4 |
//|                                              Skvorsov Konstantin |
//|                                                    skvkv@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Skvorsov Konstantin"
#property link      "skvkv@mail.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Silver
#property indicator_color2 Gold
//---- indicator parameters
extern int ma5_period=19;
extern int ma5_method=1;
extern int ma20_period=39;
extern int ma20_method=1;
extern int Signal_Period=5;
extern int Signal_method=1;

//---- indicator buffers
double TrendBuffer[];
double SignalBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
   SetIndexBuffer(0,TrendBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"BB");
//   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   IndicatorShortName("B");  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  { double ma5,ma20;
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
      {
         ma5=iMA(NULL,0,ma5_period,0,ma5_method,PRICE_CLOSE,i);
         ma20=iMA(NULL,0,ma20_period,0,ma20_method,PRICE_TYPICAL,i);
         TrendBuffer[i]=(ma5-ma20)/ma5*100;
      }
   for(i=0; i<limit; i++)
      {
         SignalBuffer[i]=iMAOnArray(TrendBuffer,0,Signal_Period,0,Signal_method,i);
      }
   return(0);
  }
//+------------------------------------------------------------------+